#!/usr/bin/env python
import sys, re, fileinput
stderr = sys.stderr

##  FakeFile
##
class FakeFile:
  
  def __init__(self, out):
    self.out = out
    self.pos = 0L
    return
  
  def write(self, s):
    self.out.write(s)
    self.pos += len(s)
    return

# adjust
HEXPAT = re.compile(r'[0-9a-f]{8}')
def adjust(fname):
  fpin = file(fname)
  fpout = file(fname+'.adjusted', 'w')
  out = FakeFile(fpout)
  prevpos = 0L
  state = 0
  for line in fpin:
    if state == 3:
      print >>stderr, 'Warning: ignored trailer: %r' % line
    elif state == 0:
      assert line.startswith('!T') and HEXPAT.match(line[4:12]), \
             'must starts with "!Tx xxxxxxxx" line: %r' % line
      out.write(line)
      state = 1
    elif line.startswith('+'):
      assert HEXPAT.match(line[1:9]), 'must starts with "+xxxxxxxx" pattern: %r' % line
      state = 2
      pos0 = prevpos
      prevpos = out.pos
      out.write('+%08x%s' % (pos0, line[9:]))
    elif line.startswith(':') and state == 2:
      out.write(line)
    elif line.startswith('.'):
      state = 3
      out.write('.\n')
      if len(line) != 2:
        print >>stderr, 'Warning: ignored trailer: %r' % line[1:]
    else:
      print >>stderr, 'Warning: ignored line: %r' % line
  assert prevpos != 0, 'empty record.'
  fpin.close()
  fpout.seek(4)
  fpout.write('%08x' % prevpos)
  fpout.close()
  return

if __name__ == "__main__":
  for fname in sys.argv[1:]:
    adjust(fname)
